'use strict';

var __awaiter$1 = (window && window.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest$1 = (window && window.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
// @ts-ignore
// error TS2525: Initializer provides no value for this binding element and the binding element has no default value (body).
function fetchCfApi(endpoint, _a = {}) {
    var { body } = _a, customConfig = __rest$1(_a, ["body"]);
    const headers = { 'Content-Type': 'application/json' };
    const config = Object.assign(Object.assign({ method: 'GET' }, customConfig), { headers: Object.assign(Object.assign({}, headers), customConfig.headers) });
    if (body) {
        if (config.method === 'GET') {
            endpoint += '?' + new URLSearchParams(body);
        }
        else {
            // @ts-ignore
            // error TS2339: Property 'body' does not exist on type '{ headers: any; method: string; }'.
            config.body = JSON.stringify(body);
        }
    }
    return window
        .fetch(endpoint, config)
        .then((response) => __awaiter$1(this, void 0, void 0, function* () {
        if (response.ok) {
            return yield response.json();
        }
        else {
            const errorMessage = yield response.json();
            return Promise.reject(new Error(errorMessage.error));
        }
    }));
}

const httpClient = (function () {
    let baseUrl_ = '';
    let baseUrlAutodetect_ = false;
    let token_ = '';
    let tokenAutodetect_ = false;
    const reset_ = () => {
        baseUrl_ = '';
        baseUrlAutodetect_ = false;
        token_ = '';
        tokenAutodetect_ = false;
    };
    const findTokenFromQueryString_ = () => {
        var _a;
        const urlParams = new URLSearchParams((_a = window === null || window === void 0 ? void 0 : window.location) === null || _a === void 0 ? void 0 : _a.search);
        const token = urlParams.get('token');
        return token ? token : '';
    };
    const findBaseUrlFromReferrer_ = () => {
        let origin = '';
        if (window && window.document && window.document.referrer) {
            const url = new URL(window.document.referrer);
            origin = url.origin;
        }
        return origin;
    };
    const getToken = () => {
        return token_;
    };
    const setToken = (newValue) => {
        tokenAutodetect_ = false;
        token_ = newValue;
    };
    const hasToken = () => {
        return token_ !== '';
    };
    const getBaseUrl = () => {
        return baseUrl_;
    };
    const setBaseUrl = (newValue) => {
        baseUrlAutodetect_ = false;
        baseUrl_ = newValue;
    };
    const hasBaseUrl = () => {
        return baseUrl_ !== '';
    };
    const hasAutodetect = () => {
        return tokenAutodetect_ && baseUrlAutodetect_;
    };
    const init = (token, baseUrl) => {
        reset_();
        if (typeof token === 'undefined') {
            token_ = findTokenFromQueryString_();
            tokenAutodetect_ = hasToken();
            //console.log('init-autodetect-token token=', token, '_tokenAutodetect=', _tokenAutodetect)
        }
        else {
            setToken(token);
        }
        if (typeof baseUrl === 'undefined') {
            baseUrl_ = findBaseUrlFromReferrer_();
            baseUrlAutodetect_ = hasBaseUrl();
            //console.log('init-autodetect-baseUrl baseUrl=', baseUrl, 'baseUrlAutodetect_=', baseUrlAutodetect_)
        }
        else {
            setBaseUrl(baseUrl);
        }
    };
    const queryMaterializedConcepts = (config) => {
        return fetchCfApi(`${baseUrl_}/api/v2/public/materialize/sql`, {
            // @ts-ignore
            // error TS2345: Argument of type '{ method: string; body: { query: string; format: "objects" | "arrays" | "arrays_with_header" | "csv" | "csv_with_header"; catalog: boolean; }; headers: { Authorization: string; }; }' is not assignable to parameter of type '{ body: any; }'.
            method: 'POST',
            body: {
                query: config.query,
                format: config.format || 'objects',
                catalog: config.catalog || false,
            },
            // @ts-ignore
            // error TS2345: Argument of type '{ body: { query: string; format: string; }; headers: { Authorization: string; }; }' is not assignable to parameter of type '{ body: any; }'.
            headers: {
                Authorization: `Bearer ${token_}`
            }
        });
    };
    const whoAmI = () => {
        return fetchCfApi(`${baseUrl_}/api/v2/users/whoami`, {
            // @ts-ignore
            // error TS2345: Argument of type '{ body: { query: string; format: string; }; headers: { Authorization: string; }; }' is not assignable to parameter of type '{ body: any; }'.
            headers: {
                Authorization: `Bearer ${token_}`
            }
        });
    };
    const autocompleteConcept = (config) => {
        return fetchCfApi(`${baseUrl_}/api/v3/coreapi/problog/queries/autocomplete`, {
            // @ts-ignore
            // TS2345: Argument of type '{ method: string; body: { uuid: string; concept: string; properties: string[]; terms: string[]; }; headers: { Authorization: string; }; }' is not assignable to parameter of type '{ body: any; }'.
            method: 'POST',
            body: {
                uuid: config.uuid,
                concept: config.concept,
                properties: config.properties,
                terms: config.terms,
                format: config.format,
                sample_size: config.sample_size,
            },
            // @ts-ignore
            // TS2345: Argument of type '{ method: string; body: { uuid: string; query: string; properties: string[]; terms: string[]; }; headers: { Authorization: string; }; }' is not assignable to parameter of type '{ body: any; }'.
            headers: {
                Authorization: `Bearer ${token_}`
            }
        });
    };
    const materializeConcept = (config) => {
        return fetchCfApi(`${baseUrl_}/api/v3/coreapi/problog/queries/execute`, {
            // @ts-ignore
            method: 'POST',
            body: {
                uuid: config.uuid,
                concept: config.concept,
                parameters: config.parameters,
                format: config.format,
                sample_size: config.sample_size,
            },
            // @ts-ignore
            headers: {
                Authorization: `Bearer ${token_}`
            }
        });
    };
    const eventStore = (type, values) => {
        const formattedType = 'event_' + type.replace(/-/g, '_').toLowerCase();
        const startDate = new Date();
        return fetchCfApi(`${baseUrl_}/api/v2/facts`, {
            // @ts-ignore
            // TS2345: Argument of type '{ method: string; body: { uuid: string; concept: string; properties: string[]; terms: string[]; }; headers: { Authorization: string; }; }' is not assignable to parameter of type '{ body: any; }'.
            method: 'POST',
            body: {
                data: [
                    {
                        type: formattedType,
                        values: values,
                        is_valid: true,
                        start_date: startDate.toISOString(),
                    }
                ],
            },
            // @ts-ignore
            // TS2345: Argument of type '{ method: string; body: { uuid: string; query: string; properties: string[]; terms: string[]; }; headers: { Authorization: string; }; }' is not assignable to parameter of type '{ body: any; }'.
            headers: {
                Authorization: `Bearer ${token_}`
            }
        });
    };
    const computeRule_ = (formattedType, properties, filters) => {
        const alea = Math.random().toString(36).substring(2, 12);
        let result = formattedType + '(';
        result += properties.map(prop => prop.toUpperCase()).join(', ');
        result += ') :- ';
        result += 'fn_mysql_materialize_facts("{{ app_url }}api/v3/facts/no_namespace/';
        result += formattedType;
        result += '?alea=' + alea;
        const filtersQuery = Object.entries(filters).map(entry => entry[0] + '=' + entry[1]).join('&');
        result += filtersQuery ? '&' + filtersQuery : '';
        result += '", "{{ client }}", "{{ env }}", "{{ sftp_host }}", "{{ sftp_username }}", "{{ sftp_password }}", ';
        result += properties.map((prop, i) => '"value_' + i + '", _, ' + prop.toUpperCase()).join(', ');
        result += ').';
        // console.log('computeRule_ = ', result);
        return result;
    };
    const eventAll = (type, properties) => {
        return eventFilter(type, properties, {});
    };
    const eventFilter = (type, properties, filters) => {
        const formattedType = 'event_' + type.replace(/-/g, '_').toLowerCase();
        const additionalRule = computeRule_(formattedType, properties, filters);
        const alea = Math.random().toString(36).substring(2, 8);
        return fetchCfApi(`${baseUrl_}/api/v3/coreapi/problog/queries/execute`, {
            // @ts-ignore
            method: 'POST',
            body: {
                uuid: '1',
                concept: alea + '_' + formattedType,
                additional_rule: alea + '_' + additionalRule,
                parameters: [],
            },
            // @ts-ignore
            headers: {
                Authorization: `Bearer ${token_}`
            }
        });
    };
    return {
        getToken: getToken,
        setToken: setToken,
        hasToken: hasToken,
        getBaseUrl: getBaseUrl,
        setBaseUrl: setBaseUrl,
        hasBaseUrl: hasBaseUrl,
        init: init,
        hasAutodetect: hasAutodetect,
        queryMaterializedConcepts: queryMaterializedConcepts,
        whoAmI: whoAmI,
        autocompleteConcept: autocompleteConcept,
        materializeConcept: materializeConcept,
        eventStore: eventStore,
        eventAll: eventAll,
        eventFilter: eventFilter,
    };
})();

var __awaiter = (window && window.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
/**
 * Wrapper around Google Maps.
 *
 * Example:
 * ```html
 * <!DOCTYPE html>
 * <html lang="en">
 * <head>
 *   <meta charset="UTF-8">
 * </head>
 * <body>
 *   <google-maps
 *     api-key="<your_api_key>"
 *     width="100%"
 *     height="160px"
 *     type="plan"
 *     address="<your_address_1>,<your_address_2>"></google-map>
 * </body>
 * <script src="https://unpkg.com/@computablefacts/sdk-javascript/dist/bundle/index.js"></script>
 * <script>
 *   cf.webComponents.registerGoogleMaps()
 * </script>
 * </html>
 * ```
 */
class GoogleMaps extends HTMLElement {
    constructor() {
        super();
    }
    connectedCallback() {
        const width = this.hasAttribute('width') ? this.getAttribute('width') : '100%';
        const height = this.hasAttribute('height') ? this.getAttribute('height') : '160px';
        const shadowRoot = this.attachShadow({ mode: 'open' });
        const template = document.createElement('div');
        template.setAttribute('class', 'wrapper');
        template.setAttribute('style', `width:${width}; height:${height};`);
        const node = template.cloneNode(true);
        shadowRoot.appendChild(node);
        this.renderMap(shadowRoot);
    }
    renderMap(shadowRoot) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.hasAttribute('api-key')) {
                throw new Error('L`attribut `api-key` est obligatoire pour faire fonctionner ce composant.');
            }
            if (!this.hasAttribute('address')) {
                throw new Error('L`attribut `address` est obligatoire pour faire fonctionner ce composant.');
            }
            // Load component attributes
            const apiKey = this.getAttribute('api-key');
            const address = this.getAttribute('address');
            const mapType = this.hasAttribute('type') ? this.getAttribute('type') : 'plan';
            const zoomControl = this.hasAttribute('zoom-control') ? this.getAttribute('zoom-control') === 'true' : true;
            const gestureHandling = this.hasAttribute('gesture-handling') ? this.getAttribute('gesture-handling') === 'true' : true;
            const card = shadowRoot.querySelector('.wrapper');
            // Get the URL to the Google Maps library
            const cf = window.cf;
            const url = `https://maps.googleapis.com/maps/api/js?key=${apiKey}&libraries=&v=weekly`;
            // Geocode an address (i.e. get the latitude and longitude) and it on the map
            const drawMap = function () {
                if (!cf.google.maps.isLoaded) {
                    setTimeout(drawMap, 150);
                }
                else {
                    const maps = [];
                    address.split(',').forEach(a => {
                        // @ts-ignore
                        // error TS2304: Cannot find name 'google'
                        new google.maps.Geocoder().geocode({
                            'address': a
                        }, function (results, status) {
                            // @ts-ignore
                            // error TS2304: Cannot find name 'google'
                            if (status == google.maps.GeocoderStatus.OK) {
                                if (maps.length === 0) {
                                    // @ts-ignore
                                    // error TS2304: Cannot find name 'google'
                                    const map = new google.maps.Map(card, {
                                        // @ts-ignore
                                        // error TS2304: Cannot find name 'google'
                                        mapTypeId: mapType === 'satellite' ? google.maps.MapTypeId.SATELLITE : google.maps.MapTypeId.PLAN,
                                        center: results[0].geometry.location,
                                        zoom: 17,
                                        gestureHandling: gestureHandling ? 'auto' : 'none',
                                        zoomControl: zoomControl,
                                    });
                                    maps.push(map);
                                }
                                // @ts-ignore
                                // error TS2304: Cannot find name 'google'
                                new google.maps.Marker({
                                    position: results[0].geometry.location,
                                    map: maps[0],
                                    title: `${a}`,
                                });
                            }
                        });
                    });
                }
            };
            if (typeof cf.google.maps.scriptUrl === 'string') {
                drawMap();
            }
            else {
                cf.google.maps.scriptUrl = url;
                cf.google.maps.isLoaded = false;
                const script = document.createElement('script');
                script.setAttribute('src', url);
                script.onload = function () {
                    cf.google.maps.isLoaded = true;
                    drawMap();
                };
                document.body.appendChild(script);
            }
        });
    }
}

/**
 * Wrapper around an autocomplete.
 *
 * This component is not meant to be instantiated but to be subclassed.
 */
class Autocomplete extends HTMLElement {
    constructor() {
        super();
        this.SELECT_VALUE = 'Select value...';
        this.THERE_ARE_NO_RESULTS_FOR_YOUR_SEARCH = 'There are no results for your search.';
        this.POPUP_WIDTH = '100%';
        this.POPUP_HEIGHT = 'auto';
        this.uuid = 0;
    }
    static extractTermBeforeCaret(text, caret) {
        const prevComma = text.lastIndexOf(',', caret - 1);
        const prevWhitespace = text.lastIndexOf(' ', caret - 1);
        const begin = prevComma < 0 && prevWhitespace < 0 ? 0 : Math.max(prevComma, prevWhitespace);
        const length = caret - begin;
        return text.substr(begin, length).trim();
    }
    static extractTermsBeforeCaret(text, caret) {
        const prevComma = text.lastIndexOf(',', caret - 1);
        const begin = prevComma < 0 ? 0 : prevComma;
        const length = caret - begin;
        return text.substr(begin, length).trim().split(' ').filter(str => str && str.length > 0);
    }
    static moveSelection(wrapper, curItem, nextItem) {
        if (curItem) {
            curItem.classList.remove('list-item_hover');
        }
        if (nextItem) {
            const top = nextItem.offsetTop;
            const bottom = nextItem.offsetTop + nextItem.offsetHeight;
            const scrollTop = wrapper.scrollTop;
            const scrollBottom = wrapper.scrollTop + wrapper.offsetHeight;
            const isVisible = (top >= scrollTop && bottom <= scrollBottom);
            if (!isVisible && bottom > scrollBottom) {
                wrapper.scrollTop = bottom - wrapper.offsetHeight;
            }
            if (!isVisible && top < scrollTop) {
                wrapper.scrollTop = top;
            }
            nextItem.classList.add('list-item_hover');
        }
    }
    static selectedItem(shadowRoot) {
        return shadowRoot.querySelector('.list-item_hover');
    }
    static previousItem(shadowRoot) {
        const selection = Autocomplete.selectedItem(shadowRoot);
        return selection ? selection.previousElementSibling : null;
    }
    static nextItem(shadowRoot) {
        const selection = Autocomplete.selectedItem(shadowRoot);
        return selection ? selection.nextElementSibling : null;
    }
    static firstItem(shadowRoot) {
        return shadowRoot.querySelector('.list-item:first-child');
    }
    static lastItem(shadowRoot) {
        return shadowRoot.querySelector('.list-item:last-child');
    }
    static position(haystack, needle) {
        for (let i = 0; i < haystack.length; i++) {
            if (needle.trim().toLowerCase().includes(haystack[i].trim().toLowerCase())) {
                return i;
            }
        }
        return -1;
    }
    static insertSelectedItem(text, caret, item, selections) {
        // console.log('text : ' + text);
        // console.log('caret : ' + caret);
        // console.log('selections : ' + selections);
        const prevComma = text.lastIndexOf(',', caret - 1);
        const nextComma = text.indexOf(',', caret);
        // console.log('prev comma : ' + prevComma)
        // console.log('next comma : ' + nextComma)
        const beginGroup = prevComma < 0 ? 0 : prevComma + 1;
        const endGroup = nextComma < 0 ? text.length : nextComma;
        // console.log('begin group : ' + beginGroup)
        // console.log('end group : ' + endGroup)
        // console.log('group : ' + text.substr(beginGroup, endGroup - beginGroup))
        const prevTokens = text.substr(beginGroup, caret - beginGroup);
        const nextTokens = text.substr(caret, endGroup - caret);
        // console.log('words before caret : ' + prevTokens)
        // console.log('words after caret : ' + nextTokens)
        const prevSelectionPosition = Autocomplete.position(selections, prevTokens);
        const nextSelectionPosition = Autocomplete.position(selections, nextTokens);
        // console.log('selection before caret : ' + (prevSelectionPosition < 0 ? 'n/a' : selections[prevSelectionPosition]))
        // console.log('selection after caret : ' + (nextSelectionPosition < 0 ? 'n/a' : selections[nextSelectionPosition]))
        let prefix = text.substr(0, beginGroup).trim();
        let suffix = text.substr(endGroup, text.length - endGroup).trim();
        if (prefix.endsWith(',')) {
            prefix = prefix.substr(0, prefix.length - 1).trim();
        }
        if (suffix.startsWith(',')) {
            suffix = suffix.substr(1, suffix.length - 1).trim();
        }
        // console.log('prefix : ' + prefix)
        // console.log('suffix : ' + suffix)
        if (prevSelectionPosition >= 0) {
            prefix = (prefix.length <= 0 ? '' : prefix + ', ') + selections[prevSelectionPosition];
        }
        if (nextSelectionPosition >= 0) {
            suffix = selections[nextSelectionPosition] + (suffix.length <= 0 ? '' : ', ' + suffix);
        }
        // console.log('adjusted prefix : ' + prefix)
        // console.log('adjusted suffix : ' + suffix)
        return (prefix.length <= 0 ? '' : prefix + ', ') + item.replace(',', '') + (suffix.length <= 0 ? '' : ', ' + suffix);
    }
    get value() {
        const val = this.getAttribute('value');
        return val && val.trim() !== '' ? val : '';
    }
    set value(newValue) {
        //console.log('newValue=', newValue);
        this.setAttribute('value', newValue);
        if (this.shadowRoot) {
            const field = this.shadowRoot.querySelector('.field');
            if (field.value != newValue) {
                field.value = newValue;
                //console.log('field value updated to:', newValue);
            }
        }
    }
    connectedCallback() {
        const placeholder = this.getAttributeOrDefault('placeholder', this.SELECT_VALUE);
        const popupWidth = this.getAttributeOrDefault('popup-width', this.POPUP_WIDTH);
        const popupHeight = this.getAttributeOrDefault('popup-height', this.POPUP_HEIGHT);
        const shadowRoot = this.attachShadow({ mode: 'open' });
        shadowRoot.innerHTML = `
            <style>
                .wrapper {
                    position: relative;
                }
                .field {
                    background: #fff;
                    height: 40px;
                    margin: 0;
                    padding: 0 0 0 1em;
                    width: calc(100% - 1em);
                    border: 1px solid #dfe1e5;
                    outline: none;
                }
                .popup {
                    position: absolute;
                    z-index: 3;
                    width: ${popupWidth};
                    background: #fff;
                    box-shadow: 0 4px 6px rgb(32 33 36 / 28%);
                    display: none;
                    margin: 0;
                    padding: 0;
                    border: 0;
                    overflow: hidden;
                }
                .list {
                    max-height: ${popupHeight};
                    overflow-y: auto;
                    list-style-type: none;
                    margin: 0;
                    padding: 0;
                }
                .list-item {
                    padding: 0.5em 0 0.5em 1em;
                }
                .list-item:hover {
                    /* DO NOT REMOVE */
                } 
                .list-item_hover {
                    background: #eee;
                }
            </style>
	    `;
        const template = document.createElement('div');
        template.setAttribute('class', 'wrapper');
        template.insertAdjacentHTML('afterbegin', `
            <input class="field" type="text" placeholder="${placeholder}"/>
            <div class="popup">
                <ul class="list"></ul>
            </div>
        `);
        const node = template.cloneNode(true);
        shadowRoot.appendChild(node);
        const field = shadowRoot.querySelector('.field');
        const popup = shadowRoot.querySelector('.popup');
        const list = shadowRoot.querySelector('.list');
        let text = ''; // the text presently in the input
        let caretStart = 0; // the start position of the caret
        let caretStartPrev = 0; // the previous start position of the caret
        let caretEnd = 0; // the end position of the caret
        let caretEndPrev2 = 0; // the previous end position of the caret
        const selections = []; // the user-selected items
        field.onblur = event => {
            event.stopImmediatePropagation();
            event.preventDefault();
            // Move to the next search identifier i.e. discard all search that did not return yet
            ++this.uuid;
            // If the input loses the focus, close the list and cleanup the DOM
            selections.length = 0;
            list.innerHTML = '';
            popup.style.display = 'none';
        };
        field.onkeyup = event => {
            event.stopImmediatePropagation();
            event.preventDefault();
            // Extract the input text
            text = field.value;
            this.value = field.value;
            // Move to the next search identifier i.e. discard all search that did not return yet
            ++this.uuid;
            // Save the current and previous caret position in order to be able to override
            // the default behavior on ARROW_UP and ARROW_DOWN
            caretStartPrev = caretStart;
            caretStart = field.selectionStart;
            caretEndPrev2 = caretEnd;
            caretEnd = field.selectionEnd;
            if (!text || text.length <= 0) {
                // If the field is empty, close the list and cleanup the DOM
                selections.length = 0;
                list.innerHTML = '';
                popup.style.display = 'none';
            }
            else if (event.key === 'Escape') {
                // If the user pressed the ESC key, close the list and cleanup the DOM
                selections.length = 0;
                list.innerHTML = '';
                popup.style.display = 'none';
            }
            else if (event.key === 'ArrowDown') {
                // Override the input default behavior iif the list is visible
                if (popup.style.display === 'block') {
                    // Reset caret position otherwise the selected item might not be inserted at the right place
                    field.selectionStart = caretStartPrev;
                    field.selectionEnd = caretEndPrev2;
                    caretStart = caretStartPrev;
                    caretEnd = caretEndPrev2;
                    // Move selection to the next list item (if any)
                    // Otherwise, select the first list item
                    const curItem = Autocomplete.selectedItem(shadowRoot);
                    const nextItem = Autocomplete.nextItem(shadowRoot);
                    const firstItem = Autocomplete.firstItem(shadowRoot);
                    Autocomplete.moveSelection(list, curItem, (nextItem ? nextItem : firstItem));
                }
            }
            else if (event.key === 'ArrowUp') {
                // Override the input default behavior iif the list is visible
                if (popup.style.display === 'block') {
                    // Reset caret position otherwise the selected item might not be inserted at the right place
                    field.selectionStart = caretStartPrev;
                    field.selectionEnd = caretEndPrev2;
                    caretStart = caretStartPrev;
                    caretEnd = caretEndPrev2;
                    // Move selection to the previous list item (if any)
                    // Otherwise, select the last list item
                    const curItem = Autocomplete.selectedItem(shadowRoot);
                    const prevItem = Autocomplete.previousItem(shadowRoot);
                    const lastItem = Autocomplete.lastItem(shadowRoot);
                    Autocomplete.moveSelection(list, curItem, (prevItem ? prevItem : lastItem));
                }
            }
            else if (event.key === 'Enter') {
                // Override the input default behavior iif the list is visible
                if (popup.style.display === 'block') {
                    // If a list item has been selected, insert this item at the caret position in the input
                    const selectedItem = Autocomplete.selectedItem(shadowRoot);
                    if (selectedItem) {
                        // Backup caret position to later move it after the inserted item
                        const caretStartTmp = caretStart;
                        const caretEndTmp = caretEnd;
                        // Insert the selected item in the input
                        const itemText = selectedItem.getAttribute('value');
                        field.value = Autocomplete.insertSelectedItem(text, caretStart, itemText, selections);
                        this.value = field.value;
                        selections.push(itemText);
                        // Catch the click event and creates a custom event for the parent(s) to catch
                        const b64Fact = selectedItem.getAttribute('b64fact');
                        if (b64Fact) {
                            shadowRoot.dispatchEvent(new CustomEvent('item-selected', {
                                bubbles: true,
                                composed: true,
                                detail: {
                                    type: 'fact',
                                    value: JSON.parse(atob(b64Fact))
                                },
                            }));
                        }
                        else {
                            shadowRoot.dispatchEvent(new CustomEvent('item-selected', {
                                bubbles: true,
                                composed: true,
                                detail: {
                                    type: 'string',
                                    value: field.value
                                },
                            }));
                        }
                        // Move caret to the end of the inserted text, otherwise it will jump to the end of the input
                        const newCaretStart = field.value.indexOf(',', caretStartTmp);
                        const newCaretEnd = field.value.indexOf(',', caretEndTmp);
                        field.selectionStart = newCaretStart < 0 ? field.value.length : newCaretStart;
                        field.selectionEnd = newCaretEnd < 0 ? field.value.length : newCaretEnd;
                        caretStart = field.selectionStart;
                        caretEnd = field.selectionEnd;
                    }
                    // At last, close the list
                    popup.style.display = 'none';
                }
            }
            else if (/^[0-9A-Za-zÀ-ÖØ-öø-ÿ-_]$/i.test(event.key)) {
                // Remove previously inserted list items
                list.innerHTML = '';
                // Build a list of items and fill the DOM
                const self = this;
                this.debounce(() => this.newListOfItems(self.uuid, text, caretStart).then(response => {
                    if (response && self.uuid === response.uuid) {
                        // At last, render the DOM and display the list items
                        response.elements.forEach(e => list.appendChild(e));
                        popup.style.display = response.elements.length > 0 ? 'block' : 'none';
                    }
                }), 250);
            }
            else {
                // Close the list
                popup.style.display = 'none';
            }
        };
        list.onmouseover = event => {
            event.stopImmediatePropagation();
            event.preventDefault();
            // If a list item is already selected, move the item CSS class from the selected one to the hovered one
            const curItem = Autocomplete.selectedItem(shadowRoot);
            if (event.target.classList.contains('list-item')) {
                Autocomplete.moveSelection(list, curItem, event.target);
            }
            else {
                // Find the first parent with the 'list-item' class
                const li = event.target.closest('.list-item');
                Autocomplete.moveSelection(list, curItem, li);
            }
        };
        list.onmousedown = event => {
            event.stopImmediatePropagation();
            event.preventDefault();
            // Move to the next search identifier i.e. discard all search that did not return yet
            ++this.uuid;
            // If a list item has been selected, insert this item at the caret position in the input
            const selectedItem = Autocomplete.selectedItem(shadowRoot);
            if (selectedItem) {
                // Backup caret position to later move it after the inserted item
                const caretStartTmp = caretStart;
                const caretEndTmp = caretEnd;
                // Insert the selected item in the input
                const value = selectedItem.getAttribute('value');
                if (value !== this.THERE_ARE_NO_RESULTS_FOR_YOUR_SEARCH) {
                    field.value = Autocomplete.insertSelectedItem(text, caretStart, value, selections);
                    this.value = field.value;
                    selections.push(value);
                    // Catch the click event and creates a custom event for the parent(s) to catch
                    const b64Fact = selectedItem.getAttribute('b64fact');
                    if (b64Fact) {
                        shadowRoot.dispatchEvent(new CustomEvent('item-selected', {
                            bubbles: true,
                            composed: true,
                            detail: {
                                type: 'fact',
                                value: JSON.parse(atob(b64Fact))
                            },
                        }));
                    }
                    else {
                        shadowRoot.dispatchEvent(new CustomEvent('item-selected', {
                            bubbles: true,
                            composed: true,
                            detail: {
                                type: 'string',
                                value: field.value
                            },
                        }));
                    }
                }
                // Move caret to the end of the inserted text, otherwise it will jump to the end of the input
                const newCaretStart = field.value.indexOf(',', caretStartTmp);
                const newCaretEnd = field.value.indexOf(',', caretEndTmp);
                field.selectionStart = newCaretStart < 0 ? field.value.length : newCaretStart;
                field.selectionEnd = newCaretEnd < 0 ? field.value.length : newCaretEnd;
                caretStart = field.selectionStart;
                caretEnd = field.selectionEnd;
            }
            // At last, close the list and cleanup the DOM
            list.innerHTML = '';
            popup.style.display = 'none';
            // Ensure the focus stays in the input
            field.focus();
        };
    }
    /**
     * Create a single `HTMLElement` of type `<li>` to replace the ones displayed in the popup. This `HTMLElement`
     * must represent a single list item.
     *
     * @param value the list item `value`.
     * @param html the list item visible name.
     * @param fact an optional fact with additional information.
     * @returns the newly created `HTMLElement`.
     */
    newListItem(value, html, fact) {
        const listItem = document.createElement('li');
        listItem.setAttribute('class', 'list-item');
        listItem.setAttribute('value', value);
        if (fact && fact.trim() !== '') {
            listItem.setAttribute('b64fact', btoa(fact));
        }
        listItem.innerHTML = html;
        return listItem;
    }
    /**
     * Create a list of `HTMLElement` to replace the ones displayed in the popup. This list of `HTMLElement`
     * must represent the full list.
     *
     * @param uuid a unique identifier in order to be able to apply updates in the right order.
     * @param text the text in the `<input>` field of the `Autocomplete` component.
     * @param caret the caret position in the text.
     * @returns a `Promise<ListOfItems>`.
     */
    newListOfItems(uuid, text, caret) {
        // console.log('text : ' + text);
        // console.log('caret : ' + caret);
        // eslint-disable-next-line @typescript-eslint/no-this-alias
        const self = this;
        return new Promise(function (resolve) {
            return resolve({
                uuid: uuid,
                elements: [
                    self.newListItem('no-results', self.THERE_ARE_NO_RESULTS_FOR_YOUR_SEARCH)
                ]
            });
        });
    }
    /**
     * Execute `getAttribute` and returns a default value if the attribute does not exist or is `null`
     * or equals to the empty string.
     *
     * @param attribute the attribute name.
     * @param defaultValue the default value to return.
     * @protected
     */
    getAttributeOrDefault(attribute, defaultValue) {
        if (!this.hasAttribute(attribute)) {
            return defaultValue;
        }
        const value = this.getAttribute(attribute);
        return value && value.trim() !== '' ? value : defaultValue;
    }
    /**
     * Ensure calls to `newListOfItems` are not performed on each keystroke.
     *
     * @param func the function to execute.
     * @param delay the delay in milliseconds to wait for before executing the function.
     * @private
     */
    debounce(func, delay) {
        window.clearTimeout(this.timeout);
        this.timeout = window.setTimeout(func, delay);
    }
}

/**
 * Wrapper around an autocomplete over concepts.
 *
 * Example:
 * ```html
 * <!DOCTYPE html>
 * <html lang="en">
 * <head>
 *   <meta charset="UTF-8">
 * </head>
 * <body>
 *   <div style="width: 50%">
 *     <autocomplete-concept
 *       popup-width="600px"
 *       popup-height="auto"
 *       popup-max-items="15"
 *       placeholder="Enter an address..."
 *       concept="address"
 *       filter-properties="NUMERO_DE_RUE,RUE,COMPLEMENT_DE_RUE,CODE_POSTAL,VILLE"
 *       title-properties="NUMERO_DE_RUE,RUE,COMPLEMENT_DE_RUE,CODE_POSTAL,VILLE"
 *       subtitle-properties="NUMERO_DE_RUE,RUE,COMPLEMENT_DE_RUE,CODE_POSTAL,VILLE"></autocomplete-concept>
 *   </div>
 *   <div>
 *     The popup will be displayed above this text.
 *   </div>
 * </body>
 * <script src="https://unpkg.com/@computablefacts/sdk-javascript/dist/bundle/index.js"></script>
 * <script>
 *   cf.webComponents.registerAutocompleteConcept()
 * </script>
 * </html>
 * ```
 */
class AutocompleteConcept extends Autocomplete {
    constructor() {
        super();
        this.UNKNOWN_CONCEPT = 'unk';
        this.UNKNOWN_PROPERTIES = 'unk';
        this.UNKNOWN_MAX_ITEMS = '15';
    }
    newListOfItems(uuid, text, caret) {
        const sampleSize = parseInt(this.getAttributeOrDefault('popup-max-items', this.UNKNOWN_MAX_ITEMS).trim(), 10);
        const concept = this.getAttributeOrDefault('concept', this.UNKNOWN_CONCEPT).trim();
        const filterProperties = this.getAttributeOrDefault('filter-properties', this.UNKNOWN_PROPERTIES).trim();
        const titleProperties = this.getAttributeOrDefault('title-properties', this.UNKNOWN_PROPERTIES).trim();
        const subtitleProperties = this.getAttributeOrDefault('subtitle-properties', this.UNKNOWN_PROPERTIES).trim();
        const terms = Autocomplete.extractTermsBeforeCaret(text, caret);
        const term = terms.pop(); // Get and remove the last term in terms : it is the one to complete
        if (concept === this.UNKNOWN_CONCEPT || filterProperties === this.UNKNOWN_PROPERTIES || !term || (term.length < 3 && terms.length <= 0)) {
            return new Promise(function (resolve) {
                return resolve({ uuid: uuid, elements: [] });
            });
        }
        // eslint-disable-next-line @typescript-eslint/no-this-alias
        const self = this;
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        const cf = window.cf;
        return cf.httpClient.autocompleteConcept({
            uuid: uuid.toString(),
            concept: concept ? concept : '',
            properties: filterProperties ? filterProperties.split(',').filter(p => p && p.trim() !== '') : [],
            terms: [terms.concat([term]).map(term => term + '*')],
            sample_size: sampleSize,
        }).then(response => {
            // @ts-ignore
            // error TS2339: Property 'id' does not exist on type 'Response'
            // error TS2339: Property 'results' does not exist on type 'Response'
            if (!response || !response.id || !response.results) {
                return {
                    uuid: -1 /* ensure the response is discarded because it is lower than the min. uuid (i.e. 0) */,
                    elements: []
                };
            }
            // @ts-ignore
            // error TS2339: Property 'results' does not exist on type 'Response'
            const results = response.results;
            const elements = [];
            const titleProps = titleProperties && titleProperties !== this.UNKNOWN_PROPERTIES ?
                titleProperties.split(',').filter(p => p && p.trim() !== '') :
                [];
            const subtitleProps = subtitleProperties && subtitleProperties !== this.UNKNOWN_PROPERTIES ?
                subtitleProperties.split(',').filter(p => p && p.trim() !== '') :
                [];
            const termUpperCase = term.toUpperCase();
            for (let i = 0; i < results.length; i++) {
                const item = results[i];
                const title = [];
                const subtitle = [];
                // Build title
                for (let k = 0; k < titleProps.length; k++) {
                    const key = titleProps[k];
                    if (key in item) {
                        const value = item[key] ? item[key].trim() : '';
                        if (value && value !== '' && value.indexOf('MASKED_') < 0) {
                            title.push(value.toUpperCase());
                        }
                    }
                }
                // Build subtitle
                for (let k = 0; k < subtitleProps.length; k++) {
                    const key = subtitleProps[k];
                    if (key in item) {
                        const value = item[key] ? item[key].trim() : '';
                        if (value && value !== '' && value.indexOf('MASKED_') < 0) {
                            const keyLowerCase = key.toLowerCase();
                            const valueLowerCase = value.toLowerCase();
                            subtitle.push(`${keyLowerCase}: ${valueLowerCase}`);
                        }
                    }
                }
                // Fill HTML template
                const titleHtml = title.map(str => {
                    const index = str.indexOf(termUpperCase);
                    if (index < 0) {
                        return str;
                    }
                    const prefix = str.substr(0, index);
                    const suffix = str.substr(index + termUpperCase.length);
                    return `${prefix}<span style="background-color: #ededed">${termUpperCase}</span>${suffix}`;
                }).join(' ');
                const subtitleHtml = subtitle.join(' <span style="font-weight: bold">/</span> ');
                if (titleHtml && titleHtml.trim().length > 0) {
                    const listItem = `
                            <div style="color: black">
                                ${titleHtml}
                            </div>
                            <div style="color: #707070">
                                ${subtitleHtml}
                            </div>
                        `;
                    const fact = {
                        concept: concept,
                        properties: item,
                    };
                    const newListItem = self.newListItem(title.join(' '), listItem, JSON.stringify(fact));
                    elements.push(newListItem);
                }
            }
            // Sort list items by title
            elements.sort(function (a, b) {
                return a.innerHTML.toLowerCase().localeCompare(b.innerHTML.toLowerCase());
            });
            // TODO : reorder list items
            return {
                // @ts-ignore
                // error TS2339: Property 'id' does not exist on type 'Response'
                uuid: parseInt(response.id, 10),
                elements: elements
            };
        }).catch(error => {
            console.log(error);
            return { uuid: uuid, elements: [] };
        });
    }
}

const webComponents = (function () {
    const registerGoogleMaps = () => {
        window.customElements.define('google-maps', GoogleMaps);
        return true;
    };
    const registerAutocompleteConcept = () => {
        window.customElements.define('autocomplete-concept', AutocompleteConcept);
        return true;
    };
    return {
        registerGoogleMaps: registerGoogleMaps,
        registerAutocompleteConcept: registerAutocompleteConcept,
    };
})();

var __rest = (window && window.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
class MemoizedPromise {
    /**
     * Create a new object that memoizes promises returned by a user-defined function.
     *
     * @param userDefinedFunction user-defined function that returns a promise.
     * @param cacheIndefinitely if true, indefinitely cache the promise.
     */
    constructor(userDefinedFunction, cacheIndefinitely) {
        this.cache = {};
        this.hit = 0;
        this.miss = 0;
        this.error = 0;
        this.cacheIndefinitely = cacheIndefinitely === true;
        this.userDefinedFunction = userDefinedFunction;
        this.request = this.request.bind(this);
    }
    request(_a) {
        var { cacheKey } = _a, params = __rest(_a, ["cacheKey"]);
        if (!cacheKey) {
            this.error++;
            return Promise.reject(new Error('Unique key not passed'));
        }
        if (this.cache[cacheKey]) {
            this.hit++;
            return this.cache[cacheKey];
        }
        this.cache[cacheKey] = this.userDefinedFunction(params)
            .then((res) => {
            if (!this.cacheIndefinitely) {
                delete this.cache[cacheKey];
            }
            return res;
        })
            .catch((err) => {
            delete this.cache[cacheKey];
            throw err;
        });
        this.miss++;
        return this.cache[cacheKey];
    }
    logStats() {
        console.log('# errors : ' + this.error);
        console.log('# entries : ' + (this.hit + this.miss));
        console.log('# hits : ' + this.hit);
        console.log('# misses : ' + this.miss);
        if (this.hit > 0) {
            console.log('hit rate : ' + (this.hit / (this.hit + this.miss)));
        }
        if (this.miss > 0) {
            console.log('miss rate : ' + (this.miss / (this.hit + this.miss)));
        }
    }
}
const cache = (function () {
    let map_ = {};
    let hit_ = 0;
    let miss_ = 0;
    const put = (namespace, key, value) => {
        if (!hasKey(namespace, key)) {
            miss_++;
            map_[namespace] = map_[namespace] || {};
            map_[namespace][key] = { data: value, hit: 0, touchedAt: new Date() };
        }
    };
    const get = (namespace, key) => {
        if (!hasKey(namespace, key)) {
            return null;
        }
        hit_++;
        map_[namespace][key].hit++;
        map_[namespace][key].touchedAt = new Date();
        return map_[namespace][key].data;
    };
    const hasKey = (namespace, key) => {
        return namespace in map_ && key in map_[namespace];
    };
    const size = () => {
        return hit_ + miss_;
    };
    const invalidate = () => {
        logStats();
        map_ = {};
        hit_ = 0;
        miss_ = 0;
    };
    const logStats = () => {
        console.log('# entries : ' + (hit_ + miss_));
        console.log('# hits : ' + hit_);
        console.log('# misses : ' + miss_);
        if (hit_ > 0) {
            console.log('hit rate : ' + (hit_ / (hit_ + miss_)));
        }
        if (miss_ > 0) {
            console.log('miss rate : ' + (miss_ / (hit_ + miss_)));
        }
    };
    const temporarilyMemoizedPromise = (fn) => {
        return new MemoizedPromise(fn, false);
    };
    const indefinitelyMemoizedPromise = (fn) => {
        return new MemoizedPromise(fn, true);
    };
    return {
        put: put,
        get: get,
        hasKey: hasKey,
        size: size,
        invalidate: invalidate,
        logStats: logStats,
        temporarilyMemoizedPromise: temporarilyMemoizedPromise,
        indefinitelyMemoizedPromise: indefinitelyMemoizedPromise,
    };
})();

const cf = (function () {
    return {
        httpClient: httpClient,
        webComponents: webComponents,
        cache: cache,
        google: {
            maps: {
                scriptUrl: null,
                isLoaded: false,
            },
        },
    };
})();

// Inspire by: https://unpkg.com/vue@2.6.14/dist/vue.js
if (typeof exports === 'object' && typeof module !== 'undefined') {
    module.exports = { cf };
}
if (typeof window === 'object') {
    window.cf = cf;
}
//console.log('typeof exports=', typeof exports)
//console.log('exports=', exports)
//console.log('typeof module=', typeof module)
//console.log('module=', module)
