import { CacheInterface } from './cache.interface';
export declare class MemoizedPromise {
    private hit;
    private miss;
    private error;
    private readonly cache;
    private readonly cacheIndefinitely;
    private readonly userDefinedFunction;
    /**
     * Create a new object that memoizes promises returned by a user-defined function.
     *
     * @param userDefinedFunction user-defined function that returns a promise.
     * @param cacheIndefinitely if true, indefinitely cache the promise.
     */
    constructor(userDefinedFunction: (params: any) => Promise<any>, cacheIndefinitely: boolean | null);
    request({ cacheKey, ...params }: {
        cacheKey: string;
    }): Promise<any>;
    logStats(): void;
}
declare const cache: CacheInterface;
export { cache };
