/**
 * Wrapper around Google Maps.
 *
 * Example:
 * ```html
 * <!DOCTYPE html>
 * <html lang="en">
 * <head>
 *   <meta charset="UTF-8">
 * </head>
 * <body>
 *   <google-maps
 *     api-key="<your_api_key>"
 *     width="100%"
 *     height="160px"
 *     type="plan"
 *     address="<your_address_1>,<your_address_2>"></google-map>
 * </body>
 * <script src="https://unpkg.com/@computablefacts/sdk-javascript/dist/bundle/index.js"></script>
 * <script>
 *   cf.webComponents.registerGoogleMaps()
 * </script>
 * </html>
 * ```
 */
declare class GoogleMaps extends HTMLElement {
    constructor();
    connectedCallback(): void;
    protected renderMap(shadowRoot: ShadowRoot): Promise<void>;
}
export { GoogleMaps };
